Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/Mex_Jac_SP.f
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/Mex_Jac_SP.f	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/Mex_Jac_SP.f	(revision 2696)
@@ -0,0 +1,43 @@
+
+      SUBROUTINE mexFunction( nlhs, plhs, nrhs, prhs )
+C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+C               Matlab Gateway for the Sparse Jacobian Function Jac_SP
+C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+      INTEGER nlhs, nrhs
+      INTEGER plhs(*), prhs(*)
+      INTEGER mxGetPr, mxCreateFull, mxGetM, mxgetN
+      INTEGER VPtr, FPtr, RPtr, JVSPtr
+      KPP_REAL V(KPP_NVAR), F(KPP_NFIX), RCT(KPP_NREACT)
+      KPP_REAL JVS(KPP_LU_NONZERO)
+
+C Check for the right number of input arguments
+      IF ( nrhs .ne. 3 ) THEN
+         CALL mexErrMsgTxt('Jac_SP requires 3 input vectors: 
+     &V(KPP_NVAR), F(KPP_NFIX), RCT(KPP_NREACT)')
+      END IF 
+C Check for the right number of output arguments
+      IF ( nlhs .ne. 1 ) THEN
+         CALL mexErrMsgTxt('Jac_SP requires 1 output vector: 
+     &JVS(KPP_LU_NONZERO)')
+      END IF 
+
+      plhs(1) = mxCreateDoubleMatrix(KPP_LU_NONZERO,1,0)
+
+      VPtr = mxGetPr(prhs(1))
+      CALL mxCopyPtrToReal8(VPtr,V,KPP_NVAR)
+      
+      FPtr = mxGetPr(prhs(2))
+      CALL mxCopyPtrToReal8(FPtr,F,KPP_NFIX)
+      
+      RPtr = mxGetPr(prhs(3))
+      CALL mxCopyPtrToReal8(RPtr,RCT,KPP_NREACT)
+
+      JVSPtr = mxGetPr(plhs(1))
+
+      CALL Jac_SP( V, F, RCT, JVS )
+
+      CALL mxCopyReal8ToPtr(JVS, JVSPtr, KPP_LU_NONZERO)
+
+      RETURN 
+      END
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/Mex_Jac_SP.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/Mex_Jac_SP.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/Mex_Jac_SP.f90	(revision 2696)
@@ -0,0 +1,44 @@
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+ SUBROUTINE mexFunction( nlhs, plhs, nrhs, prhs )
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!          Matlab Gateway for the Sparse Jacobian Function Jac_SP
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+ USE KPP_ROOT_Model
+
+      INTEGER nlhs, nrhs
+      INTEGER plhs(*), prhs(*)
+      INTEGER mxGetPr, mxCreateFull, mxGetM, mxgetN
+      INTEGER VPtr, FPtr, RPtr, JVSPtr
+      KPP_REAL V(KPP_NVAR), F(KPP_NFIX), RCT(KPP_NREACT)
+      KPP_REAL JVS(KPP_LU_NONZERO)
+
+! Check for the right number of input arguments
+      IF ( nrhs .ne. 3 ) THEN
+         CALL mexErrMsgTxt('Jac_SP requires 3 input vectors: &
+     &V(KPP_NVAR), F(KPP_NFIX), RCT(KPP_NREACT)')
+      END IF 
+! Check for the right number of output arguments
+      IF ( nlhs .ne. 1 ) THEN
+         CALL mexErrMsgTxt('Jac_SP requires 1 output vector: &
+     &JVS(KPP_LU_NONZERO)')
+      END IF 
+
+      plhs(1) = mxCreateDoubleMatrix(KPP_LU_NONZERO,1,0)
+
+      VPtr = mxGetPr(prhs(1))
+      CALL mxCopyPtrToReal8(VPtr,V,KPP_NVAR)
+      
+      FPtr = mxGetPr(prhs(2))
+      CALL mxCopyPtrToReal8(FPtr,F,KPP_NFIX)
+      
+      RPtr = mxGetPr(prhs(3))
+      CALL mxCopyPtrToReal8(RPtr,RCT,KPP_NREACT)
+
+      JVSPtr = mxGetPr(plhs(1))
+
+      CALL Jac_SP( V, F, RCT, JVS )
+
+      CALL mxCopyReal8ToPtr(JVS, JVSPtr, KPP_LU_NONZERO)
+
+ END SUBROUTINE mexFunction
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/Template_Fun_Chem.m
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/Template_Fun_Chem.m	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/Template_Fun_Chem.m	(revision 2696)
@@ -0,0 +1,22 @@
+
+% Wrapper for calling the ODE function routine
+% in a format required by Matlab's ODE integrators
+
+function P = KPP_ROOT_Fun_Chem(T, Y) 
+     
+  global TIME FIX RCONST  
+ 
+  Told = TIME;
+  TIME = T;
+  KPP_ROOT_Update_SUN;
+  KPP_ROOT_Update_RCONST;
+  
+%  This line calls the Matlab ODE function routine  
+  P = KPP_ROOT_Fun( Y, FIX, RCONST );
+  
+%  To call the mex routine instead, comment the line above and uncomment the following line:
+%  P = KPP_ROOT_mex_Fun( Y, FIX, RCONST );
+
+  TIME = Told;
+
+return
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/Template_Jac_Chem.m
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/Template_Jac_Chem.m	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/Template_Jac_Chem.m	(revision 2696)
@@ -0,0 +1,32 @@
+
+% Wrapper for calling the sparse ODE Jacobian routine
+% in a format required by Matlab's ODE integrators
+
+function J =  KPP_ROOT_Jac_Chem(T, Y)   
+  
+  global TIME FIX RCONST 
+%  To call the mex file uncomment one of the following lines:
+%     1) LU prefix if SPARSE_LU_ROW option was used in code generation
+%  global LU_IROW LU_ICOL 
+%     2) if SPARSE_ROW option was used in code generation
+%  global IROW ICOL 
+  
+  Told = TIME;
+  TIME = T;
+  KPP_ROOT_Update_SUN;
+  KPP_ROOT_Update_RCONST;
+  
+%  This line calls the Matlab ODE Jacobian routine  
+  J = KPP_ROOT_Jac_SP( Y, FIX, RCONST );
+  
+%  To call the mex routine instead, comment the line above and uncomment one of the following lines:
+%     1) LU prefix if SPARSE_LU_ROW option was used in code generation
+%  J = sparse( LU_IROW, LU_ICOL, ...
+%        KPP_ROOT_mex_Jac_SP( Y, FIX, RCONST ), KPP_NVAR, KPP_NVAR); 
+%     2) if SPARSE_ROW option was used in code generation
+%  J = sparse( IROW, ICOL, ...
+%        KPP_ROOT_mex_Jac_SP( Y, FIX, RCONST ), KPP_NVAR, KPP_NVAR); 
+
+  TIME = Told;
+  
+return              
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UpdateSun.c
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UpdateSun.c	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UpdateSun.c	(revision 2696)
@@ -0,0 +1,20 @@
+void Update_SUN()
+{
+KPP_REAL SunRise, SunSet;
+KPP_REAL Thour, Tlocal, Ttmp; 
+const KPP_REAL PI = 3.14159265358979;  
+
+  SunRise = 4.5;
+  SunSet  = 19.5;
+  Thour = TIME/3600.0;
+  Tlocal = Thour - ((int)Thour/24)*24;
+
+  if ( (Tlocal >= SunRise) && (Tlocal <= SunSet) ) {
+    Ttmp = (2.0*Tlocal-SunRise-SunSet)/(SunSet-SunRise);
+    if (Ttmp > 0) Ttmp =  Ttmp*Ttmp;
+             else Ttmp = -Ttmp*Ttmp;
+    SUN = ( 1.0 + cos(PI*Ttmp) )/2.0; 
+  } else {
+    SUN=0.0;
+  }
+}
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UpdateSun.f
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UpdateSun.f	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UpdateSun.f	(revision 2696)
@@ -0,0 +1,30 @@
+      SUBROUTINE Update_SUN()
+
+      IMPLICIT NONE
+      INCLUDE 'KPP_ROOT_Parameters.h'
+      INCLUDE 'KPP_ROOT_Global.h'
+
+      KPP_REAL SunRise, SunSet
+      KPP_REAL Thour, Tlocal, Ttmp, PI
+      PARAMETER (PI = 3.14159265358979d0) 
+   
+      SunRise = 4.5
+      SunSet  = 19.5
+      Thour = TIME/3600.
+      Tlocal = Thour - (INT(Thour)/24)*24
+
+      IF ((Tlocal.GE.SunRise).AND.(Tlocal.LE.SunSet)) THEN
+        Ttmp = (2.0*Tlocal-SunRise-SunSet)/(SunSet-SunRise)
+        IF (Ttmp.GT.0) THEN
+          Ttmp =  Ttmp*Ttmp
+        ELSE
+          Ttmp = -Ttmp*Ttmp
+        END IF
+        SUN = ( 1.0 + COS(PI*Ttmp) )/2.0 
+      ELSE
+        SUN = 0.0
+      END IF
+
+      RETURN
+      END
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UpdateSun.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UpdateSun.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UpdateSun.f90	(revision 2696)
@@ -0,0 +1,30 @@
+  SUBROUTINE Update_SUN()
+      !USE KPP_ROOT_Parameters
+      !USE KPP_ROOT_Global
+
+    IMPLICIT NONE
+
+    KPP_REAL :: SunRise, SunSet
+    KPP_REAL :: Thour, Tlocal, Ttmp 
+    ! PI - Value of pi
+    KPP_REAL, PARAMETER :: PI = 3.14159265358979d0
+    
+    SunRise = 4.5_dp 
+    SunSet  = 19.5_dp 
+    Thour = TIME/3600.0_dp 
+    Tlocal = Thour - (INT(Thour)/24)*24
+
+    IF ((Tlocal>=SunRise).AND.(Tlocal<=SunSet)) THEN
+       Ttmp = (2.0*Tlocal-SunRise-SunSet)/(SunSet-SunRise)
+       IF (Ttmp.GT.0) THEN
+          Ttmp =  Ttmp*Ttmp
+       ELSE
+          Ttmp = -Ttmp*Ttmp
+       END IF
+       SUN = ( 1.0_dp + COS(PI*Ttmp) )/2.0_dp 
+    ELSE
+       SUN = 0.0_dp 
+    END IF
+
+ END SUBROUTINE Update_SUN
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UpdateSun.m
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UpdateSun.m	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UpdateSun.m	(revision 2696)
@@ -0,0 +1,23 @@
+function Update_SUN( )
+
+global TIME SUN
+ 
+   SunRise = 4.5;
+   SunSet  = 19.5;
+   Thour = TIME/3600.;
+   Tlocal = Thour - floor(Thour/24)*24;
+
+   if ( (Tlocal>=SunRise) & (Tlocal<=SunSet) ) 
+     Ttmp = (2.0*Tlocal-SunRise-SunSet)/(SunSet-SunRise);
+     if (Ttmp>0) 
+       Ttmp =  Ttmp*Ttmp;
+     else
+       Ttmp = -Ttmp*Ttmp;
+     end 
+     SUN = ( 1.0 + cos(pi*Ttmp) )/2.0 ;
+   else
+     SUN = 0.0;
+   end 
+
+return % Update_SUN
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.c
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.c	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.c	(revision 2696)
@@ -0,0 +1,67 @@
+/*  User-defined Rate Law functions
+    Note: the default argument type for rate laws, as read from the equations file, is single precision
+         but all the internal calculations are performed in double precision
+*/
+/* Arrhenius */
+KPP_REAL  ARR( float A0, float B0, float C0 )
+      {
+      double ARR_RES;
+                 
+      ARR_RES = (double)A0 * exp( -(double)B0/TEMP ) 
+                * pow( (TEMP/300.0), (double)C0 );   
+           
+      return (KPP_REAL)ARR_RES;
+      }           
+
+
+/* Simplified Arrhenius, with two arguments */
+/* Note that the argument B0 has a changed sign when compared to ARR */
+KPP_REAL  ARR2(  float A0, float B0 )
+      {
+      double ARR_RES;           
+
+      ARR_RES =  (double)A0 * exp( (double)B0/TEMP );   
+           
+      return (KPP_REAL)ARR_RES;
+      }           
+
+
+KPP_REAL  EP2( float A0, float C0, float A2, float C2, float A3, float C3)
+      {                       
+      double K0, K2, K3, EP2_RES;
+      
+      K0 = (double)A0 * exp( -(double)C0/TEMP );
+      K2 = (double)A2 * exp( -(double)C2/TEMP );
+      K3 = (double)A3 * exp( -(double)C3/TEMP );
+      K3 = K3*CFACTOR*1.0e+6;
+      EP2_RES = K0 + K3/( 1.0+K3/K2 );
+        
+      return (KPP_REAL)EP2_RES;
+      }  
+
+
+KPP_REAL  EP3( float A1, float C1, float A2, float C2) 
+      {               
+      double K1, K2, EP3_RES;
+      
+      K1 = (double)A1 * exp(-(double)C1/TEMP);
+      K2 = (double)A2 * exp(-(double)C2/TEMP);
+      EP3_RES = K1 + K2*(1.0e+6*CFACTOR);
+      
+      return (KPP_REAL)EP3_RES;
+      }    
+
+
+KPP_REAL  FALL (  float A0, float B0, float C0, float A1, float B1, float C1, float CF)
+      {                      
+      double K0, K1, FALL_RES;
+      
+      K0 = (double)A0 * exp(-(double)B0/TEMP)* pow( (TEMP/300.0), (double)C0 );
+      K1 = (double)A1 * exp(-(double)B1/TEMP)* pow( (TEMP/300.0), (double)C1 );
+      K0 = K0*CFACTOR*1.0e+6;
+      K1 = K0/K1;
+      FALL_RES = (K0/(1.0+K1))*
+           pow( (double)CF, ( 1.0/( 1.0+pow( (log10(K1)),2 ) ) ) );
+        
+      return (KPP_REAL)FALL_RES;
+      }
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.f
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.f	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.f	(revision 2696)
@@ -0,0 +1,76 @@
+C  User-defined Rate Law functions
+C  Note: the default argument type for rate laws, as read from the equations file, is single precision
+C        but all the internal calculations are performed in REAL*8
+
+C Arrhenius
+      KPP_REAL FUNCTION ARR( A0,B0,C0 )
+      INCLUDE 'KPP_ROOT_Parameters.h'
+      INCLUDE 'KPP_ROOT_Global.h'
+                 
+      REAL A0,B0,C0      
+      ARR =  DBLE(A0) * EXP(-DBLE(B0)/TEMP) * (TEMP/300.0D0)**DBLE(C0)   
+           
+      RETURN
+      END           
+
+
+C Simplified Arrhenius, with two arguments
+C Note: The argument B0 has a changed sign when compared to ARR
+      KPP_REAL FUNCTION ARR2( A0,B0 )
+      INCLUDE 'KPP_ROOT_Parameters.h'
+      INCLUDE 'KPP_ROOT_Global.h'
+                 
+      REAL A0,B0     
+      ARR2 =  DBLE(A0) * EXP( DBLE(B0)/TEMP )   
+           
+      RETURN
+      END           
+
+      KPP_REAL FUNCTION EP2(A0,C0,A2,C2,A3,C3)
+      INCLUDE 'KPP_ROOT_Parameters.h'                       
+      INCLUDE 'KPP_ROOT_Global.h'
+      
+      REAL A0,C0,A2,C2,A3,C3
+      REAL*8 K0,K2,K3
+      
+      K0 = DBLE(A0) * EXP(-DBLE(C0)/TEMP)
+      K2 = DBLE(A2) * EXP(-DBLE(C2)/TEMP)
+      K3 = DBLE(A3) * EXP(-DBLE(C3)/TEMP)
+      K3 = K3*CFACTOR*1.0d6
+      EP2 = K0 + K3/(1.0d0+K3/K2 )
+        
+      RETURN
+      END  
+
+
+      KPP_REAL FUNCTION EP3(A1,C1,A2,C2) 
+      INCLUDE 'KPP_ROOT_Parameters.h'               
+      INCLUDE 'KPP_ROOT_Global.h'
+      
+      REAL A1, C1, A2, C2
+      REAL*8 K1, K2
+      
+      K1 = DBLE(A1) * EXP(-DBLE(C1)/TEMP)
+      K2 = DBLE(A2) * EXP(-DBLE(C2)/TEMP)
+      EP3 = K1 + K2*(1.0d6*CFACTOR)
+      
+      RETURN
+      END    
+
+
+      KPP_REAL FUNCTION FALL ( A0,B0,C0,A1,B1,C1,CF)
+      INCLUDE 'KPP_ROOT_Parameters.h'                      
+      INCLUDE 'KPP_ROOT_Global.h'
+      
+      REAL A0,B0,C0,A1,B1,C1,CF
+      REAL*8 K0, K1
+      
+      K0 = DBLE(A0) * EXP(-DBLE(B0)/TEMP)* (TEMP/300.0D0)**DBLE(C0)
+      K1 = DBLE(A1) * EXP(-DBLE(B1)/TEMP)* (TEMP/300.0D0)**DBLE(C1)
+      K0 = K0*CFACTOR*1.0D6
+      K1 = K0/K1
+      FALL = (K0/(1.0d0+K1))*
+     *      DBLE(CF)**(1.0d0/(1.0d0+(DLOG10(K1))**2))
+        
+      RETURN
+      END
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.f90	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.f90	(revision 2696)
@@ -0,0 +1,106 @@
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!  User-defined Rate Law functions
+!  Note: the default argument type for rate laws, as read from the equations file, is single precision
+!        but all the internal calculations are performed in double precision
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!
+! RFo: IMPORTANT: Comments must ALWAYS stand BEFORE the code to be processed
+!
+!      This is just the working copy of UserRateLaws.f90 which is actually used. 
+!      It is copied from GASPASE_PREPROC/mechanisms/UserRateLaws.f90 to kpp/util/UserRateLaws.f90
+!      each time when run_kpp4palm.ksh is run. 
+
+
+!~~~>  Arrhenius
+   KPP_REAL FUNCTION ARR( A0,B0,C0 )
+      REAL A0,B0,C0      
+      ARR =  DBLE(A0) * EXP(-DBLE(B0)/TEMP) * (TEMP/300.0_dp)**DBLE(C0)
+   END FUNCTION ARR        
+
+
+!~~~> Simplified Arrhenius, with two arguments, fixed TEMP=20 deg C
+!~~~> Note: The argument B0 has a changed sign when compared to ARR
+!
+!~~~> Simplified Arrhenius, with two arguments
+! RFo: same as above, but with TEMP in parameter list and _dp
+!  KPP_REAL (kind=dp) FUNCTION ARR2( A0, B0 )
+!     REAL (kind=dp) A0,B0
+!     ARR2 =  A0 * EXP( B0 / 20.0_dp )
+!  END FUNCTION ARR2
+REAL(kind=dp) FUNCTION ARR2( a0, b0, temp )
+    REAL(kind=dp) :: temp
+    REAL(kind=dp) :: a0,b0
+    ARR2 = a0 * EXP( -b0 / temp )
+END FUNCTION ARR2
+
+
+   KPP_REAL FUNCTION EP2(A0,C0,A2,C2,A3,C3)
+      REAL A0,C0,A2,C2,A3,C3
+      REAL(kind=dp) K0,K2,K3            
+      K0 = DBLE(A0) * EXP(-DBLE(C0)/TEMP)
+      K2 = DBLE(A2) * EXP(-DBLE(C2)/TEMP)
+      K3 = DBLE(A3) * EXP(-DBLE(C3)/TEMP)
+      K3 = K3*CFACTOR*1.0E6_dp
+      EP2 = K0 + K3/(1.0_dp+K3/K2 )
+   END FUNCTION EP2
+
+   KPP_REAL FUNCTION EP3(A1,C1,A2,C2) 
+      REAL A1, C1, A2, C2
+      REAL(kind=dp) K1, K2      
+      K1 = DBLE(A1) * EXP(-DBLE(C1)/TEMP)
+      K2 = DBLE(A2) * EXP(-DBLE(C2)/TEMP)
+      EP3 = K1 + K2*(1.0E6_dp*CFACTOR)
+   END FUNCTION EP3 
+
+   KPP_REAL FUNCTION FALL ( A0,B0,C0,A1,B1,C1,CF)
+      REAL A0,B0,C0,A1,B1,C1,CF
+      REAL(kind=dp) K0, K1     
+      K0 = DBLE(A0) * EXP(-DBLE(B0)/TEMP)* (TEMP/300.0_dp)**DBLE(C0)
+      K1 = DBLE(A1) * EXP(-DBLE(B1)/TEMP)* (TEMP/300.0_dp)**DBLE(C1)
+      K0 = K0*CFACTOR*1.0E6_dp
+      K1 = K0/K1
+      FALL = (K0/(1.0_dp+K1))*   &
+           DBLE(CF)**(1.0_dp/(1.0_dp+(LOG10(K1))**2))
+   END FUNCTION FALL
+
+  !---------------------------------------------------------------------------
+
+  ELEMENTAL REAL(kind=dp) FUNCTION k_3rd(temp,cair,k0_300K,n,kinf_300K,m,fc)
+
+    INTRINSIC LOG10
+
+    REAL(kind=dp), INTENT(IN) :: temp      ! temperature [K]
+    REAL(kind=dp), INTENT(IN) :: cair      ! air concentration [molecules/cm3]
+    REAL, INTENT(IN) :: k0_300K   ! low pressure limit at 300 K
+    REAL, INTENT(IN) :: n         ! exponent for low pressure limit
+    REAL, INTENT(IN) :: kinf_300K ! high pressure limit at 300 K
+    REAL, INTENT(IN) :: m         ! exponent for high pressure limit
+    REAL, INTENT(IN) :: fc        ! broadening factor (usually fc=0.6)
+    REAL(kind=dp) :: zt_help, k0_T, kinf_T, k_ratio
+
+    zt_help = 300._dp/temp
+    k0_T    = k0_300K   * zt_help**(n) * cair ! k_0   at current T
+    kinf_T  = kinf_300K * zt_help**(m)        ! k_inf at current T
+    k_ratio = k0_T/kinf_T
+    k_3rd   = k0_T/(1._dp+k_ratio)*fc**(1._dp/(1._dp+LOG10(k_ratio)**2))
+
+  END FUNCTION k_3rd
+
+  !---------------------------------------------------------------------------
+
+  ELEMENTAL REAL(kind=dp) FUNCTION k_arr (k_298,tdep,temp)
+    ! Arrhenius function
+
+    REAL,     INTENT(IN) :: k_298 ! k at T = 298.15K
+    REAL,     INTENT(IN) :: tdep  ! temperature dependence
+    REAL(kind=dp), INTENT(IN) :: temp  ! temperature
+
+    INTRINSIC EXP
+
+    k_arr = k_298 * EXP(tdep*(1._dp/temp-3.3540E-3_dp)) ! 1/298.15=3.3540e-3
+
+  END FUNCTION k_arr
+
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!  End of User-defined Rate Law functions
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.f90_orig
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.f90_orig	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.f90_orig	(revision 2696)
@@ -0,0 +1,104 @@
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!  User-defined Rate Law functions
+!  Note: the default argument type for rate laws, as read from the equations file, is single precision
+!        but all the internal calculations are performed in double precision
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!
+! RFo: IMPORTANT: Comments must ALWAYS stand BEFORE the code to be processed
+!      This is just a savety copy. The UserRateLaws.f90 which is actually used 
+!      is copied from GASPASE_PREPROC/mechanisms/UserRateLaws.f90 to kpp/util/UserRateLaws.f90
+!      each time when run_kpp4palm.ksh is run 
+
+!~~~>  Arrhenius
+   KPP_REAL FUNCTION ARR( A0,B0,C0 )
+      REAL A0,B0,C0      
+      ARR =  DBLE(A0) * EXP(-DBLE(B0)/TEMP) * (TEMP/300.0_dp)**DBLE(C0)
+   END FUNCTION ARR        
+
+
+!~~~> Simplified Arrhenius, with two arguments, fixed TEMP=20 deg C
+!~~~> Note: The argument B0 has a changed sign when compared to ARR
+!
+!~~~> Simplified Arrhenius, with two arguments
+! RFo: same as above, but with TEMP in parameter list and _dp
+!  KPP_REAL (kind=dp) FUNCTION ARR2( A0, B0 )
+!     REAL (kind=dp) A0,B0
+!     ARR2 =  A0 * EXP( B0 / 20.0_dp )
+!  END FUNCTION ARR2
+REAL(kind=dp) FUNCTION ARR2( a0, b0, temp )
+    REAL(kind=dp) :: temp
+    REAL(kind=dp) :: a0,b0
+    ARR2 = a0 * EXP( -b0 / temp )
+END FUNCTION ARR2
+
+
+   KPP_REAL FUNCTION EP2(A0,C0,A2,C2,A3,C3)
+      REAL A0,C0,A2,C2,A3,C3
+      REAL(kind=dp) K0,K2,K3            
+      K0 = DBLE(A0) * EXP(-DBLE(C0)/TEMP)
+      K2 = DBLE(A2) * EXP(-DBLE(C2)/TEMP)
+      K3 = DBLE(A3) * EXP(-DBLE(C3)/TEMP)
+      K3 = K3*CFACTOR*1.0E6_dp
+      EP2 = K0 + K3/(1.0_dp+K3/K2 )
+   END FUNCTION EP2
+
+   KPP_REAL FUNCTION EP3(A1,C1,A2,C2) 
+      REAL A1, C1, A2, C2
+      REAL(kind=dp) K1, K2      
+      K1 = DBLE(A1) * EXP(-DBLE(C1)/TEMP)
+      K2 = DBLE(A2) * EXP(-DBLE(C2)/TEMP)
+      EP3 = K1 + K2*(1.0E6_dp*CFACTOR)
+   END FUNCTION EP3 
+
+   KPP_REAL FUNCTION FALL ( A0,B0,C0,A1,B1,C1,CF)
+      REAL A0,B0,C0,A1,B1,C1,CF
+      REAL(kind=dp) K0, K1     
+      K0 = DBLE(A0) * EXP(-DBLE(B0)/TEMP)* (TEMP/300.0_dp)**DBLE(C0)
+      K1 = DBLE(A1) * EXP(-DBLE(B1)/TEMP)* (TEMP/300.0_dp)**DBLE(C1)
+      K0 = K0*CFACTOR*1.0E6_dp
+      K1 = K0/K1
+      FALL = (K0/(1.0_dp+K1))*   &
+           DBLE(CF)**(1.0_dp/(1.0_dp+(LOG10(K1))**2))
+   END FUNCTION FALL
+
+  !---------------------------------------------------------------------------
+
+  ELEMENTAL REAL(kind=dp) FUNCTION k_3rd(temp,cair,k0_300K,n,kinf_300K,m,fc)
+
+    INTRINSIC LOG10
+
+    REAL(kind=dp), INTENT(IN) :: temp      ! temperature [K]
+    REAL(kind=dp), INTENT(IN) :: cair      ! air concentration [molecules/cm3]
+    REAL, INTENT(IN) :: k0_300K   ! low pressure limit at 300 K
+    REAL, INTENT(IN) :: n         ! exponent for low pressure limit
+    REAL, INTENT(IN) :: kinf_300K ! high pressure limit at 300 K
+    REAL, INTENT(IN) :: m         ! exponent for high pressure limit
+    REAL, INTENT(IN) :: fc        ! broadening factor (usually fc=0.6)
+    REAL(kind=dp) :: zt_help, k0_T, kinf_T, k_ratio
+
+    zt_help = 300._dp/temp
+    k0_T    = k0_300K   * zt_help**(n) * cair ! k_0   at current T
+    kinf_T  = kinf_300K * zt_help**(m)        ! k_inf at current T
+    k_ratio = k0_T/kinf_T
+    k_3rd   = k0_T/(1._dp+k_ratio)*fc**(1._dp/(1._dp+LOG10(k_ratio)**2))
+
+  END FUNCTION k_3rd
+
+  !---------------------------------------------------------------------------
+
+  ELEMENTAL REAL(kind=dp) FUNCTION k_arr (k_298,tdep,temp)
+    ! Arrhenius function
+
+    REAL,     INTENT(IN) :: k_298 ! k at T = 298.15K
+    REAL,     INTENT(IN) :: tdep  ! temperature dependence
+    REAL(kind=dp), INTENT(IN) :: temp  ! temperature
+
+    INTRINSIC EXP
+
+    k_arr = k_298 * EXP(tdep*(1._dp/temp-3.3540E-3_dp)) ! 1/298.15=3.3540e-3
+
+  END FUNCTION k_arr
+
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+!  End of User-defined Rate Law functions
+!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.m
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.m	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws.m	(revision 2696)
@@ -0,0 +1,41 @@
+%  User-defined Rate Law functions
+%  Note: insert this file at the end of Update_RCONST
+
+%---  Arrhenius
+   function [rate] =  ARR( A0,B0,C0 )
+      global TEMP CFACTOR
+      rate =  (A0) * exp(-(B0)/TEMP) * (TEMP/300.0)^(C0) ;            
+   return %  ARR        
+
+%--- Simplified Arrhenius, with two arguments
+%--- Note: The argument B0 has a changed sign when compared to ARR
+   function [rate] =  ARR2( A0,B0 )
+      global TEMP CFACTOR
+      rate =  (A0) * exp( (B0)/TEMP ) ;             
+   return %  ARR2          
+
+   function [rate] =  EP2(A0,C0,A2,C2,A3,C3)
+      global TEMP CFACTOR                       
+      K0 = (A0) * exp(-C0/TEMP);
+      K2 = (A2) * exp(-C2/TEMP);
+      K3 = (A3) * exp(-C3/TEMP);
+      K3 = K3*CFACTOR*1.0e+6;
+      rate = K0 + K3/(1.0+K3/K2) ;       
+   return %  EP2
+
+   function [rate] =  EP3(A1,C1,A2,C2) 
+      global TEMP CFACTOR               
+      K1 = (A1) * exp(-(C1)/TEMP);
+      K2 = (A2) * exp(-(C2)/TEMP);
+      rate = K1 + K2*(1.0e+6*CFACTOR);      
+   return %  EP3 
+
+   function [rate] =  FALL ( A0,B0,C0,A1,B1,C1,CF)
+      global TEMP CFACTOR                      
+      K0 = A0 * exp(-B0/TEMP)* (TEMP/300.0)^(C0);
+      K1 = A1 * exp(-B1/TEMP)* (TEMP/300.0)^(C1);
+      K0 = K0*CFACTOR*1.0e+6;
+      K1 = K0/K1;
+      rate = (K0/(1.0+K1))*(CF)^(1.0/(1.0+(log(K1))^2));        
+   return %  FALL
+
Index: palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws_FcnHeader.f
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws_FcnHeader.f	(revision 2696)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/kpp/util/UserRateLaws_FcnHeader.f	(revision 2696)
@@ -0,0 +1,6 @@
+C  Definitions for User-defined Rate Law functions
+C  To be inserted in funcions that call rate laws
+
+      KPP_REAL ARR, ARR2
+      KPP_REAL EP2, EP3, FALL
+      EXTERNAL ARR, ARR2, EP2, EP3, FALL
